const CSSelector = function(selector, context) {
	this.selector = selector;

	this.set_context();

	const number_of_occrances = this.count_number_of_occurances(this.selector);

	if (number_of_occrances === 0) return null;

	if (number_of_occrances > 1) return this.context.querySelectorAll(this.selector);

	return this.context.querySelector(this.selector);
}

CSSelector.prototype.count_number_of_occurances = function(selector) {
	this.context.querySelectorAll(this.selector).length;
}

CSSelector.prototype.set_context = function(selector, context) {
	this.context = document;
}

window.Selector = selector => new CSSelector(selector, document);
NodeList.prototype.Selector = selector => new CSSelector(selector);
Node.prototype.Selector = selector => new CSSelector(selector);
